#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <sys/types.h>
#include <syslog.h>
#include <sys/socket.h>
#include <netinet/in.h>


#include <sys/errno.h>
extern int errno;

#include <sys/un.h>
#include <sys/wait.h>

//#define SOK_FILE "/tmp/local"

#define PORT    1555

main()
{
 int bs,  c_len, max_len, sd;
 struct sockaddr_in s_a,c_a;

// daemon(1,1); /*   */

 openlog("vpsdaemon",LOG_PID | LOG_CONS, LOG_DAEMON);
 syslog(LOG_INFO,"i do work");

 sd = socket(AF_INET,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ syslog(LOG_ERR,"ERROR: Can not open socket"); exit(1); }

// unlink(SOK_FILE);
// s_len = sizeof(s_a);
 bzero(&s_a,sizeof s_a);
 s_a.sin_family = AF_INET;
// strcpy(s_a.sun_path,SOK_FILE);
// s_len = sizeof(s_a.sun_family)+strlen(s_a.sun_path);
 s_a.sin_port = htons((u_short) PORT);
 s_a.sin_addr.s_addr = INADDR_ANY;

 bs = bind(sd,(struct sockaddr*) &s_a,sizeof s_a); /*    */
 if( bs<0 ) { syslog(LOG_ERR,"ERROR: Can not bild socket `%s'",strerror(errno)); exit(2);}
 /*    */
 if(listen(sd,5)<0){ syslog(LOG_ERR,"ERROR: Can not listen socket"); exit(2); }

 for(;;)
 {
 int ns, pid;
  c_len = sizeof c_a;
  bzero(&c_a,sizeof c_a);

  ns = accept(sd,(struct sockaddr*) &c_a,&c_len); /*   */
  if( ns<0 ){ syslog(LOG_ERR,"ERROR: Can not bind socket"); exit(3);}

  syslog(LOG_INFO,"Accept...");

  pid = fork();
  if( pid==-1 ){ syslog(LOG_ERR,"ERROR: Can not create process"); exit(4);}

  if( pid==0 ) /*   */
  {
   int k, p[2], i, i2;
   int n = 0;
   char* argv[64];
   char buf[127];
   int status;

   close(sd); /*      -     */

   close(0); close(1); close(2);

while( 1 ){
   int j = 0;
   int size = read(ns,&k,sizeof k);

   if( k==0 || size!=sizeof k ) break;

   while( i=read(ns,&buf[j],1), !(i==1 && buf[j]=='\0')  )
   if( i==1 ) j++;

//   fprintf(stderr,"buf=%s\n",buf);

   argv[0] = "/bin/ps";

   argv[1] = strtok(buf," \n\t");

   for( i=2; i<63; i++)
   {
     argv[i] = strtok(NULL," \n\t");
//     syslog(LOG_INFO,"av[%i]=%s",i,argv[i]);
     if( argv[i]==0 ) break;
   }

   argv[i] = 0;

   i = pipe(p);
   if( i<0 ) syslog(LOG_ERR,"pipe not create"), exit(1);

    if( (pid=vfork())==0 ) /*   */
    {
     close(ns);
     if( dup2(p[1],1)<0 ) syslog(LOG_ERR,"child: error in dup2"), exit(1);
     close(p[0]);
     execv(argv[0],argv);
     exit(1);
    }

    close(p[1]);

    if( dup2(p[0],0)<0 ) syslog(LOG_ERR,"error in dup2"), exit(1);

    i = 0;
    while( fgets(buf,sizeof buf-1,stdin) )
    {
     if( i< k )  write(ns,buf,strlen(buf));
     i++;
    }

   close(0);

   waitpid(pid,&status,WUNTRACED);    /*   */
   status = WEXITSTATUS(status);      /*    ps */
   if( status ) write(ns,"\n     Error!   Write new command\n",34), i+=2;;

   for(; i<k; i++) write(ns,"\n",1);

} /* while end */
   syslog(LOG_INFO,"Disconnect...");
   close(ns);
   exit(0);
  }

  waitpid(pid,0,WUNTRACED);
  close(ns); /*        */
 }
 close(sd);
 closelog();
}

